Subject: RE: [Megaco] Questions about Add

From: "Kevin Boyle" <[email-masked]>
Date: Tue, 17 Sep 2002 16:44:38 -0400

Actually, if you look really closely at the usage of the word "wildcard"
throughout the spec, it is apparent through context that it means ALL and
not CHOOSE in many places.  I won't dispute that CHOOSE is, in fact, a
wildcard, but that's not how the spec is written.

I'm fine with making the change you are suggesting, but there needs to be a
thorough scrubbing of the spec to fix all the instances of misuse, rather
than just this one.

Kevin

-----Original Message-----
From: Terry L Anderson [mailto:[email-masked]] 
Sent: Tuesday, September 17, 2002 4:35 PM
To: Dinesh Pandey
Cc: Boyle, Kevin [NCRTP:3R90:EXCH]; [email-masked]
Subject: Re: [Megaco] Questions about Add

I cannot agree with Kevin that "wildcard" means ALL.  6.2.2 in fact states:

    A wildcarding mechanism using two types of wildcards can be used 
with TerminationIDs.  The two wildcards are ALL and CHOOSE. 

and the sentence in 7.2.1 just before the one cited by Dinesh uses the 
expression "CHOOSE wildcard..."  So I believe that the sentence:
    Wildcards may be used in an Add, but such usage would be unusual. is
confusing and should really say:
    ALL wildcards may be used in an Add, but such usage would be unusual.
This complements the previous sentence about CHOOSE rather than 
contradicting it.
Do folks think that this is a serious enough confusion to warrant an IG 
item?

(see other comments below)

Dinesh Pandey wrote:

>Thaks Kevin,
>	sorry about the confusion. I will restate the second question:
>
>In the description of Add command, RFC 3015 has a line
>
>"For an existing Termination, the TerminationID would be specific.  For 
>a Termination that does not yet exist, the TerminationID is specified 
>as CHOOSE  in the command."
>
>In the later version, (H.248.1 at the ITU website) this line has been 
>struck off. And the line inserted is
>
>"If a CHOOSE wildcard is used in the TermintationID, the  selected 
>TerminationID will be returned".
>
>
>Considering these changes (hopefully I have got them right), what 
>should be the correct behaviour of MG to a "Add=$". Should it return a 
>physical termination (it will match and it exists). Or should it look 
>into the descriptors to guess the type of termination. Or we should 
>avoid this construct and partially specify the termination ID to help 
>the MG make a decision.
>  
>
The change to remove the sentences you cite was made through the 
Implementors Guide specifically to remove the impression that CHOOSE 
cannot be used with physical terminations.  That is, CHOOSE is perfectly 
legal with either a physcial termination (to select among those in NULL) 
or with an ephemeral (creating a new termination).  As you note, MG can 
make this choice more easily if the terminationID is partially specified 
and the naming patterns for physical and ephemerals are distinct, but if 
this is NOT the case then MG must determine which type of termination 
can satisfy the enclosed descriptors.

>thanks,
>Dinesh.
>
>
>
>
>
>
>-----Original Message-----
>From: [email-masked] [mailto:[email-masked]]On Behalf Of 
>Kevin Boyle
>Sent: Tuesday, September 17, 2002 12:01 PM
>To: Dinesh Pandey; [email-masked]
>Subject: RE: [Megaco] Questions about Add
>
>
>Comments inline. [KJBII]
>
>Kevin
>
>-----Original Message-----
>From: Dinesh Pandey [mailto:[email-masked]]
>Sent: Tuesday, September 17, 2002 1:02 PM
>To: [email-masked]
>Cc: [email-masked]
>Subject: [Megaco] Questions about Add
>
>
>Hi List,
>	I have a few basic doubts about the Add command. Could anyone please

>answer them
>
>1) What does the statement in section 7.2.1, para 1 mean.
>
>"Wildcards may be used in Add, but such usage would be unusual".
>
>I believe CHOOSE is also a wildcard and it is used very frequently in 
>Add commands.
>
>[KJBII] Throughout the spec when the word "wildcards" is used, it 
>generally only means '*', either by itself, or as part of a partially 
>specified identifier.
>
>2) How should the gateway execute the command 'Add = $', considering 
>the fact that the line which recommended the use of CHOOSE for creating 
>ephemeral terminations has been deleted.
>
>[KJBII] I don't understand what you're asking here.  When the MGC sends 
>A=$, then the MG should add an ephemeral.  I don't see the link between 
>this command and a "line" which has been "deleted" (subtracted?).  The 
>MGC is responsible for cleanup, not the MG.  So the MG should execute 
>the command as best it can, unless there is an obvious error, such as 
>trying to add the ephemeral to a non-existent context.
>
>thanks in advance,
>any help would be appreciated,
>Dinesh.
>
>_______________________________________________
>Megaco mailing list
>[email-masked]
>https://www1.ietf.org/mailman/listinfo/megaco
>_______________________________________________
>Megaco mailing list
>[email-masked]
>https://www1.ietf.org/mailman/listinfo/megaco
>
>_______________________________________________
>Megaco mailing list
>[email-masked]
>https://www1.ietf.org/mailman/listinfo/megaco
>  
>

-- 

------------------------------------------------------------
Terry L Anderson, CMTS          mailto:[email-masked]
Tel:732.949.5628   Fax:732.949.7016
Lucent Technologies/INS/Voice Over IP Access Networks
Rm 2G-219A, 101 Crawfords Corner Rd, Holmdel, NJ 07733-3030
http://its.lucent.com/~tla (Lucent internal) http://www.gti.net/tla

_______________________________________________
Megaco mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/megaco

---

From: Christian Groves <[email-masked]>
Date: Wed, 18 Sep 2002 10:22:13 +1000

G'Day Kevin and Terry,

I always thought that wilcarded terminationID was ALL "*" within the scope of a
termination ID. ALL Termination ID is different to the context ID because it
allows partial specification, thus fred/* is still wildcarded as is *. I don't
see how the spec goes against this.

Regards, Christian

---

From: Christian Groves <[email-masked]>
Date: Wed, 18 Sep 2002 10:22:13 +1000

G'Day Kevin and Terry,

Regards, Christian

---

From: "Madhu Babu Brahmanapally" <[email-masked]>
Date: Tue, 17 Sep 2002 18:48:28 -0700

Hi All,
In section 6.2.2. its mentioned that
"A wildcarding mechanism using two types of wildcards can be used with
   TerminationIDs. The two wildcards are ALL and CHOOSE." At least as far as
terminationIds are concerned, a wildcard can be either ALL or CHOOSE (of
course partial specifications also). Coming to Dinesh's query about
"Wildcards may be used in Add, but such usage would be unusual", here the
wildcard "IMO" address only the * wildcard and not CHOOSE wildcard. Fully
specifying the type of wildcard in this section will remove the ambiguity on
the type of wildcard. If there are any such statements, then they also needs
to be fully qualified by the type of wildcard to avoid any further
confusion.

Regards
Madhubabu Brahmanapally.

Syndeo Corporation
695 Campbell Technology Parkway
Campbell, CA 95008
Phone 408.376.1151
Fax 408.861.9801

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of
Christian Groves
Sent: Tuesday, September 17, 2002 5:22 PM
To: Kevin Boyle
Cc: Terry L Anderson; Dinesh Pandey; [email-masked]
Subject: Re: [Megaco] Questions about Add

G'Day Kevin and Terry,

I always thought that wilcarded terminationID was ALL "*" within the scope
of a
termination ID. ALL Termination ID is different to the context ID because it
allows partial specification, thus fred/* is still wildcarded as is *. I
don't
see how the spec goes against this.

Regards, Christian

---

From: "Madhu Babu Brahmanapally" <[email-masked]>
Date: Tue, 17 Sep 2002 18:48:28 -0700

Hi All,

Regards
Madhubabu Brahmanapally.

Syndeo Corporation

-----Original Message-----

G'Day Kevin and Terry,

Regards, Christian